local DC = DeltaChars

DC.DEBUGPREFIX = "\132Del\129taCh\138ars:\128 "

DC.debug = CV_RegisterVar(
{
	name = "dc_debug",
	PossibleValue = CV_OnOff,
	defaultvalue = "Off"
})

function DC.Print(...)
	local str = ...
	if str == nil
		return
	end
	
	print(DC.DEBUGPREFIX .. str)
	DC.Print(select(2, ...))
end

function DC.DebugPrint(...)
	if DC.debug.value
		DC.Print(...)
	end
end

function DC.DebugHUD(v, player)
	local delta = player.deltaChars
	
	if not delta
	or not DC.debug.value
		return
	end
	
	local STEP = 4
	local x = 16
	local y = 56
	local flags = V_SNAPTOLEFT|V_SNAPTOTOP
	
	local function DrawString(str, extraFlags)
		if str ~= nil
			v.drawString(x, y, str, flags|(extraFlags or 0), "small")
		end
		y = $ + STEP
	end
	
	DrawString("Flags:")
	
	for flag, value in pairs(DC.FLAGS)
		if flag:find("MASK")
			continue
		end
		
		DrawString(flag, (delta.flags & value) and V_GREENMAP or V_REDMAP)
	end
	
	/*DrawString()
	DrawString("Combo coyote time:")
	DrawString(delta.comboCoyoteTics, delta.comboCoyoteTics > 0 and V_GREENMAP or V_REDMAP)
	
	DrawString()
	DrawString("Charge time:")
	DrawString(delta.chargeTime,
		delta.chargeTime < delta.CHARGETHRESHOLD and V_REDMAP
		or delta.chargeTime < delta.FULLCHARGETIME and V_ORANGEMAP
		or V_GREENMAP)*/
end

hud.add(DC.DebugHUD)