/*
Deltarune dialogue sequencer

v1
*/

// LOSERS!!!! THIS LIBRARY SUCKS!!!!

local DC = DeltaChars
local DB = {}

DC.DialogueBox = DB

//dc_dialogue command
local default = "On"
DC.dialogueFileName = "client/DeltaChars/Dialogue.dat"

local file = io.openlocal(DC.dialogueFileName)
if file
	local num = file:read("*n")
	if num == 0
		default = "Off"
	end
	file:close()
end

DC.dialogue = CV_RegisterVar({
	name = "dc_dialogue",
	defaultvalue = default,
	flags = CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = function(cv)
		if cv.value
			print("DeltaChars dialogue will now play in singleplayer.")
		else
			print("DeltaChars dialogue will no longer play in singleplayer.")
		end
		if io
			local file = io.openlocal(DC.dialogueFileName, "w+")
			file:write(cv.value)
			file:close()
		end
	end
})

DB.patches = {}
DB.events = {}
DB.hooks = {}
DB.seenDialogue = {}

DB.WORD_SPLITTERS = {' ', '\n'}

DB.BORDER_X = 7*FRACUNIT
DB.BORDER_Y = 7*FRACUNIT

DB.PORTRAIT_X_OFFSET = 15*FRACUNIT
DB.PORTRAIT_Y_OFFSET = 12*FRACUNIT

DB.TEXT_X_OFFSET = 26*FRACUNIT
DB.TEXT_X_OFFSET_PORTRAIT = 84*FRACUNIT
DB.TEXT_Y_OFFSET = 20*FRACUNIT

DB.LINE_STAR_OFFSET = -16*FRACUNIT
DB.LINE_BREAK = 18*FRACUNIT
DB.SPACE = 8*FRACUNIT

DB.TEXT_COLORS = {
	SKINCOLOR_DC_SPARE,
	SKINCOLOR_MAGENTA,
	SKINCOLOR_YELLOW,
	SKINCOLOR_EMERALD,
	SKINCOLOR_BLUE,
	SKINCOLOR_RED,
	SKINCOLOR_GREY,
	SKINCOLOR_ORANGE,
	SKINCOLOR_SKY,
	SKINCOLOR_PURPLE,
	SKINCOLOR_AQUA,
	SKINCOLOR_PERIDOT,
	SKINCOLOR_AZURE,
	SKINCOLOR_BROWN,
	SKINCOLOR_ROSY,
	SKINCOLOR_BLACK
}

local TYPES = {}
TYPES.DIALOGUE = 1
TYPES.DELAY = 2
TYPES.COROUTINE = 3
DB.TYPES = TYPES

local DF = {}
DF.STASIS = 1 << 0 // locks the player's controls, allowing them to control the flow of text with jump/spin buttons
DF.FLIP_BOX = 1 << 1 // the box is usually on top of the screen, or on the bottom in reverse gravity. This flag inverts its placement.
DB.FLAGS = DF	

// returns the font patch corresponding to a char
function DB.GetCharPatch(v, char)
	return v.cachePatch("DRFNT"..(char:byte()))
end

// adds the classic undertale asterisk to the start of the current line
function DB.AddLineStar(entry)
	table.insert(entry.letters, {
		x = entry.xStart + DB.LINE_STAR_OFFSET,
		y = entry.y,
		char = '*',
		color = DB.TEXT_COLORS[1]
	})
end

// returns whether @char splits words
function DB.CharSplitsWords(char)
	for _, char2 in ipairs(DB.WORD_SPLITTERS)
		if char == char2
			return true
		end
	end
	return false
end

function DB.CharIsVisible(char)
	local byte = char:byte()
	return byte >= 33 and byte <= 126
end

function DB.CharIsLetter(char)
	local byte = char:byte()
	return byte >= 48 and byte <= 57 // numbers
		or byte >= 65 and byte <= 90 // uppercase letters
		or byte >= 97 and byte <= 122 // lowercase letters
end

// finds the next "word" and returns the fixed-scale width of it
function DB.GetNextWordWidth()
	local text = DB.current.text
	local length = text:len()
	local width = 0
	
	local i = 1
	
	while i <= length
		local char = text:sub(i, i)
		
		for _, splitter in ipairs(DB.WORD_SPLITTERS)
			if char == splitter
				return width * DB.SPACE
			end
		end
		
		if DB.CharIsVisible(char)
			width = $ + 1
		end
		
		i = $ + 1
	end
	
	return width * DB.SPACE
end

// returns whether or not @x coordinate fits within the space of the box
function DB.WithinBoxX(x)
	return x <= (DB.patches.box.width - 1) * FRACUNIT - 2*DB.BORDER_X
end

// returns whether or not @y coordinate fits within the space of the box
function DB.WithinBoxY(y)
	return y <= DB.patches.box.height * FRACUNIT - 2*DB.BORDER_Y
end

// draws the box
function DB.DrawDialogueBox(v, player)
	local box = DB.patches.box
	
	if not DC.Valid(box)
		box = v.cachePatch("DR_DIALOGUEBOX")
		DB.patches.box = box
	end
	
	local x = (320 - box.width)/2 * FRACUNIT
	local y
	local flags
	
	if not (player.mo and player.mo.eflags & MFE_VERTICALFLIP
	and not (player.pflags & PF_FLIPCAM)) ~= not (DB.current.event.flags & DF.FLIP_BOX)
		y = (199 - box.height)*FRACUNIT
		flags = V_SNAPTOBOTTOM
	else
		y = FRACUNIT
		flags = V_SNAPTOTOP
	end
	
	v.drawScaled(x, y, FRACUNIT, box, flags)
	
	return x, y, flags
end

// draws the text
function DB.DrawDialogue(v, player)
	local c = DB.current
	
	if not c
	or c.type ~= TYPES.DIALOGUE
		return
	end
	
	local x, y, flags = DB.DrawDialogueBox(v, player)
	
	x = $ + DB.BORDER_X
	y = $ + DB.BORDER_Y
	
	if c.blankTics > 0
		return
	end
	
	if c.portrait
		local x, y = x + DB.PORTRAIT_X_OFFSET, y + DB.PORTRAIT_Y_OFFSET
		v.drawScaled(x, y, FRACUNIT, v.cachePatch(c.portrait), flags)
		if c.overlay
			v.drawScaled(x, y, FRACUNIT, v.cachePatch(c.overlay), flags)
		end
	end
	
	for i, letter in ipairs(c.letters)
		if not letter.patch
			letter.patch = DB.GetCharPatch(v, letter.char)
			letter.colormap = v.getColormap(TC_DEFAULT, letter.color)
		end
		v.drawScaled(x + letter.x, y + letter.y, FRACUNIT, letter.patch, flags, letter.colormap)
	end
end

// run once per tic to animate the text
function DB.UpdateDialogue()
	local c = DB.current
	
	if not c
		return
	end
	
	// this is a delay, not dialogue
	if c.type == TYPES.DELAY
		c.delay = $ - 1
		if c.delay <= 0
			DB.AdvanceQueue()
		end
		return
	end
	
	// this is an action, not dialogue
	if c.type == TYPES.COROUTINE
		local ok, result = coroutine.resume(c.thread, consoleplayer)
		
		if result == nil
			return
		end
		
		if not ok
			DC.Print("\133Coroutine error: \128"..result)
		end
		DB.AdvanceQueue()
		return
	end
	
	// get button inputs if relevant
	local jump
	local spin
	
	if c.event.flags & DF.STASIS
	and DC.CheckStatus(consoleplayer)
		local buttons = consoleplayer.deltaChars.buttons
		jump = buttons[BT_JUMP]
		spin = buttons[BT_SPIN]
	end
	
	// no text left, allow advancing
	if c.text == ""
		if c.event.flags & DF.STASIS
			if jump == 1 or spin == 1
				DB.AdvanceQueue()
			end
		else
			c.countdown = $ - 1
			if c.countdown <= 0
				DB.AdvanceQueue()
			end
		end
		return
	end
	
	if c.blankTics > 0
		c.blankTics = $ - 1
		return
	end
	
	// artificial delay before next character is processed
	if c.delay > 0
		c.delay = $ - 1
		return
	end
	
	local result = DB.AddDialogueChars(spin and c.text:len() or 1)
	
	if result > 0
		S_StartSound(nil, c.name and DB.talkers[c.name].sound or sfx_drtalk)
	elseif result < 0
		c.text = ""
	end
end

function DB.AddDialogueChars(num)
	local c = DB.current
	local result = 0
	
	for i = 1, num
		// snip the first character from the string
		local char = c.text:sub(1, 1)
		local nextChar = c.text:sub(2, 2)
		
		c.text = $:sub(2)
		
		// special case: newline
		if char == '\n'
			c.x = c.xStart
			c.y = $ + DB.LINE_BREAK
			DB.AddLineStar(c)
			continue
		end
		
		// special case: space
		if char == ' '
			local wordWidth = DB.GetNextWordWidth()
			c.x = $ + DB.SPACE
			if not DB.WithinBoxX(c.x + wordWidth)
				c.x = c.xStart
				c.y = $ + DB.LINE_BREAK
			end
			c.delay = c.setDelay - 1
			continue
		end
		
		if not DB.CharIsVisible(char)
			local byte = char:byte()
			
			// special case: abrupt ending
			if byte == 127
				DB.AdvanceQueue()
				return -1
			end
			
			// special case: delay setters
			if byte >= 0 and byte <= 31
				c.setDelay = byte
			end
			
			// special case: colors
			if byte >= 128 and byte <= 143
				c.color = DB.TEXT_COLORS[byte - 127]
			end
			
			i = $ - 1 // does not count as a character
			continue
		end
		
		// all chars from here onwards create sound
		result = 1
		
		// add delays for punctuation characters
		if c.setDelay > 0
			c.delay = c.setDelay - 1
		elseif DB.CharSplitsWords(nextChar)
			if char == ','
				c.delay = 6
			elseif char == ';'
			or char == ':'
			or char == "-"
				c.delay = 7
			elseif char == '.'
			or char == '?'
			or char == '!'
				c.delay = 8
			end
		end
		
		if not DB.WithinBoxX(c.x + DB.SPACE) // this word fills more than an entire line, so wrap it
			c.x = c.xStart
			c.y = $ + DB.LINE_BREAK
		end
		
		if not DB.WithinBoxY(c.y) // oops we overflowed the box
			return -1
		end
		
		// add the character to the draw list
		table.insert(c.letters, {
			x = c.x,
			y = c.y,
			char = char,
			color = c.color
		})
		c.x = $ + DB.SPACE
	end
	return result
end

function DB.AddEvent(event)
	local hookArg = event.hookArg or MT_NULL
	event.flags = $ or 0
	event.hookType = $ or "MapLoad"
	if not DB.hooks[hookArg]
		DB.hooks[hookArg] = {}
	end
	if not DB.hooks[hookArg][event.hookType]
		DC.AddHook(event.hookType, function(...)
			DB.PollEvents(hookArg, event.hookType, ...)
		end, event.hookArg)
		DB.hooks[hookArg][event.hookType] = true
	end
	
	table.insert(DB.events, event)
end

function DB.GetEventsForMap(mapNum)
	local availableEvents = {}
	
	local map = mapheaderinfo[mapNum]
	local zone = map and map.lvlttl:lower()
	local act = map and map.actnum
	
	for i = #DB.events, 1, -1
		local event = DB.events[i]
		if (event.zone ~= nil
		and event.zone:lower() ~= zone)
		or (event.act ~= nil
		and event.act ~= act)
		or (event.preCondition ~= nil
		and not event.preCondition())
		or (event.save ~= false
		and DB.seenDialogue[event.tag])
			continue
		end
		
		local hookArg = event.hookArg or MT_NULL
		local eventList = availableEvents[hookArg]
		
		if not eventList
			eventList = {}
			availableEvents[hookArg] = eventList
		end
		
		if not eventList[event.hookType]
			eventList[event.hookType] = {}
		end
		
		eventList = eventList[event.hookType]
		
		table.insert(eventList, event)
	end
	return availableEvents
end

function DB.ClearEvents()
	DB.availableEvents = nil
	DB.queue = nil
	DB.current = nil
	DB.previousTalkerName = nil
end

function DB.MakeDialogueEntry(entry, event)
	local x
	local portrait, overlay
	local name = entry.name
	
	if name
		local talker
		name = $:lower()
		talker = DB.talkers[name]
		if talker.prefix
			portrait = talker.prefix .. "_" .. (entry.portraitNum or talker.default)
			overlay = talker.overlay
		end
	end
	
	x = portrait and DB.TEXT_X_OFFSET_PORTRAIT or DB.TEXT_X_OFFSET
	
	entry = {
		type = TYPES.DIALOGUE,
		name = name,
		portrait = portrait,
		overlay = overlay,
		text = entry.text,
		delay = 1,
		setDelay = 0,
		blankTics = 0,
		countdown = entry.countdown == nil and 2*TICRATE or entry.countdown,
		xStart = x,
		x = x,
		y = DB.TEXT_Y_OFFSET,
		color = DB.TEXT_COLORS[1],
		letters = {},
		event = event
	}
	DB.AddLineStar(entry)
	return entry
end

function DB.MakeCoroutineEntry(entry, event)
	return {
		type = TYPES.COROUTINE,
		thread = coroutine.create(entry),
		event = event
	}
end

function DB.MakeDelayEntry(entry, event)
	return {
		type = TYPES.DELAY,
		delay = entry,
		event = event
	}
end

function DB.QueueEvent(event)
	table.insert(DB.queue, event)
	if not DB.current
		DB.AdvanceQueue()
	end
end

function DB.LoadEvents(mapNum)
	DB.availableEvents = DB.GetEventsForMap(mapNum)
	DB.queue = {}
	DB.nextIndex = 1
end

function DB.CutCurrentEvents()
	DB.current = nil
	DB.queue = {}
	DB.nextIndex = 1
end

function DB.AdvanceQueue()
	DB.index = DB.nextIndex
	local event = DB.queue[1]
	
	// have we reached the end of this event's script?
	if not event.script[DB.index]
		DB.seenDialogue[event.tag] = true
		table.remove(DB.queue, 1)
		DB.index = 1
		event = DB.queue[1]
	end
	
	// is there an active event?
	if event
		local entry = event.script[DB.index]
		local t = type(entry)
		
		if t == "table" // table = dialogue
			local item = DB.MakeDialogueEntry(entry, event)
			if DB.previousTalkerName ~= item.name
				item.blankTics = 4
				DB.previousTalkerName = item.name
			end
			DB.current = item
		else
			if t == "number" // number = delay
				DB.current = DB.MakeDelayEntry(entry, event)
			elseif t == "function" // function = coroutine
				DB.current = DB.MakeCoroutineEntry(entry, event)
			end
			DB.previousTalkerName = nil
		end
		DB.nextIndex = DB.index + 1
	else
		DB.current = nil
		DB.nextIndex = 1
	end
end

function DB.ApplyDialogueFlagEffects()	
	if DB.current
	and DB.current.event.flags & DF.STASIS
	and DC.IsDeltaChar(consoleplayer)
		consoleplayer.powers[pw_nocontrol] = max($, 2) & ~(1 << 15)
		consoleplayer.pflags = $ | PF_FULLSTASIS | PF_JUMPDOWN
	end
end

function DB.PollEvents(hookArg, hookType, ...)
	local eventList = DB.GetEventList(hookArg, hookType)
	
	if not eventList
		return
	end
	
	for i = #eventList, 1, -1
		local event = eventList[i]
		
		if event.condition == nil
		or event.condition(...)
			DB.QueueEvent(event)
			table.remove(eventList, i)
			continue
		end
	end
end

function DB.GetEventList(hookArg, hookType)
	local eventList = DB.availableEvents
	
	if eventList == nil
		return
	end
	
	eventList = $[hookArg]
	
	return eventList and eventList[hookType]
end

// -----
// hooks
// -----

hud.add(function(v, player, cam)
	DB.DrawDialogue(v, player)
end)

DC.AddHook("ThinkFrame", do
	if gamestate ~= GS_LEVEL or titlemapinaction
		DB.ClearEvents()
		return
	end
	
	DB.UpdateDialogue()
	DB.ApplyDialogueFlagEffects()
end)

DC.AddHook("MapChange", do
	DB.ClearEvents()
end)

DC.AddHook("MapLoad", function(mapNum)
	if DC.dialogue.value
	and DC.Singleplayer()
	and DC.CheckStatus(consoleplayer)
	and gamestate == GS_LEVEL
	and not titlemapinaction
		DB.LoadEvents(mapNum)
	end
end)