/*
Ralsei's Hat
	by SMS Alfredo

v1
*/

/*
	MFE_FORCESUPER got added before this released, so thankfully no followmobj!
	Look out for SMS Alfredo's painful hat of death in DeltaChars.lua and ChitChat.lua
	Maybe this code should go into Ralsei.lua...
*/

local DC = DeltaChars
local Ralsei = DC.Ralsei

function Ralsei.IterateHat()
	for player in players.iterate do
		Ralsei.DoHat(player, player.mo)
	end
end

function Ralsei.DoHat(player, mo, hat)
	if not mo then return end
	if mo.skin == Ralsei.SKIN and player.ralseihat
		mo.ralseihat = true
		if not (mo.eflags & MFE_FORCESUPER)
			mo.eflags = $ | MFE_FORCESUPER
			mo.state = $
		end
	elseif mo.ralseihat
		mo.ralseihat = nil
		mo.eflags = $ &~ MFE_FORCESUPER
		mo.state = $
	end
	
	return true
end

//Signpost Junk
function Ralsei.SignpostHat(mobj)
	if mobj.state != S_SIGNPLAYER then return end
	
	local mo = mobj.target
	local player = mo and mo.valid and mo.player
	if not player or player.followitem != skins[Ralsei.SKIN].followitem
	or not player.ralseihat then return end
	
	local ov = mobj.tracer and mobj.tracer.valid and mobj.tracer.tracer
	if not ov.valid or ov.skin != Ralsei.SKIN then return end
	
	local hat = ov.tracer or P_SpawnMobjFromMobj(ov, 0,0,0, MT_OVERLAY)
	ov.tracer = hat
	hat.target = mobj.tracer
	hat.tracer = mobj.tracer
	
	hat.skin = ov.skin
	hat.color = ov.color
	hat.colorized = ov.colorized
	
	ov.flags2 = $ | MF2_DONTDRAW
	
	hat.state = ov.state
	hat.tics = -1
	hat.frame = ov.frame
	hat.sprite2 = ov.sprite2|FF_SPR2SUPER
end

//ralseihat command
function Ralsei.HatCommand(player, arg)
	local validcommand = false
	arg = $ and string.lower($)
	if arg == "0" or arg == "default" or arg == "off"
		player.ralseihat = 0
		validcommand = true
	elseif arg == "1" or arg == "on"
		player.ralseihat = 1
		validcommand = true
	end
	
	local mo = player.mo
	local movalid = mo and mo.valid and mo.color == player.skincolor
	local darkner = R_GetColorByName("darkner")
	if darkner
		if player.ralseihat
			if player.skincolor == skins[Ralsei.SKIN].prefcolor
				player.skincolor = darkner
			end
		elseif player.skincolor == darkner
			player.skincolor = skins[Ralsei.SKIN].prefcolor
		end
		if movalid then mo.color = player.skincolor end
	end
	
	if not validcommand
		CONS_Printf(player, "dc_ralseihat [on/off] - Toggles Ralsei's Chapter One alternative skin, where he wears his hat.")
		if player.ralseihat
			CONS_Printf(player, "Currently on.")
		else
			CONS_Printf(player, "Currently off.")
		end
	elseif io and player == consoleplayer
		local file = io.openlocal("client/DeltaChars/RalseiHat.dat", "w+")
		file:write(player.ralseihat)
		file:close()
	end
end

//Apply the I/O for the command when spawning
function Ralsei.HatIO(player)
	//I/O maybe
	if io and player == consoleplayer and player.ralseihat == nil
		local file = io.openlocal("client/DeltaChars/RalseiHat.dat")
		if file
			local num = file:read("*n")
			if num
				CommandQueue_Add("dc_ralseihat "..num)
			end
			file:close()
		end
	end
end

//Make the life icon show hat when you have hat
function Ralsei.HatHUD(v, player, cam)
	if player.skin == Ralsei.GetSkinIndex()
	and player.ralseihat and hud.enabled("lives")
	and not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS)
	and not G_IsSpecialStage()
		local color = player.skincolor
		if player.realmo and player.realmo.valid
			color = player.realmo.color
		end
		
		v.drawScaled(16*FRACUNIT, 176*FRACUNIT, FRACUNIT/2,
		v.getSprite2Patch(player.skin, SPR2_XTRA, true),
		V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER,
		v.getColormap(player.skin, color))
	end
end

DC.AddHook("PostThinkFrame", Ralsei.IterateHat)
DC.AddHook("MobjThinker", Ralsei.SignpostHat, MT_SIGN)
DC.AddHook("PlayerSpawn", Ralsei.HatIO)

COM_AddCommand("dc_ralseihat", Ralsei.HatCommand)
COM_AddCommand("dc_ralseihat2", Ralsei.HatCommand, COM_SPLITSCREEN)

hud.add(Ralsei.HatHUD)